/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_event_flag.h
 *
 *	@brief	Windows iTRONT[rXR[ (CxgtO).
 *
 *	@author	V 閾
 */
#ifndef	__WI_EVENT_FLAG_H__
#define	__WI_EVENT_FLAG_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief CxgtOIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute;		//!< CxgtO.
	UINT		FlgVal;			//!< CxgtÕrbgp^[.
	VP			ExtInfo;		//!< g.
	WIHDR		*WaitQue;		//!< ^XN̑҂s̃|C^.
} WIFLGOBJ;

/*!
 *
 * @brief CxgtȌԎQƗp\.
 *
 */
typedef struct {
	UINT		FlgVal;			//!< CxgtÕrbgp^[.
	INT			WaitId;			//!< CxgtO҂s̐擪̃^XNIDԍ.
	VP			ExtInfo;		//!< g.
} WIFLGSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitEvFlag( void );
void	wi_QuitEvFlag( void );
ER		wi_CreateEvFlag( INT id, WIFLGOBJ *obj );
ER		wi_DeleteEvFlag( INT id );
ER		wi_SetEvFlag( INT id, UINT setptn );
ER		wi_ClearEvFlag( INT id, UINT clrptn );
ER		wi_WaitEvFlag( INT id, UINT *p_flgptn, UINT waiptn, UINT wfmode, TMO tmout );
ER		wi_RefarenceEvFlag( INT id, WIFLGSTAT *sts );
void	wi_AllReleaseEvFlag( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_EVENT_FLAG_H__
/* End of file */
