/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_rendezvous_port.h
 *
 *	@brief	Windows iTRONT[rXR[ (fu).
 *
 *	@author	V 閾
 */
#ifndef	__WI_RENDEZVOUS_PORT_H__
#define	__WI_RENDEZVOUS_PORT_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief fu|[gIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute;		//!< fu|[g.
	INT			MaxCalMsg;		//!< ďõbZ[W̍ő咷.
	INT			MaxRepMsg;		//!< ԓ̃bZ[W̍ő咷.
	WIHDR		*CalWaitQue;	//!< fuďo҂^XN̑҂s̃|C^.
	WIHDR		*AcpWaitQue;	//!< fut҂^XN̑҂s̃|C^.
	VP			ExtInfo;		//!< g.
} WIPOROBJ;

/*!
 *
 * @brief fu|[gԂ̎QƗp\.
 *
 */
typedef struct {
	INT			CalWaitId;		//!< fuďo҂^XN̑҂s̐擪̃^XNIDԍ.
	INT			AcpWaitId;		//!< fut҂^XN̑҂s̐擪̃^XNIDԍ.
	VP			ExtInfo;		//!< g.
} WIPORSTAT;

/*!
 *
 * @brief fuIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	INT			TaskId;			//!< fuI҂Ă^XNIDԍ.
	INT			MaxRepMsg;		//!< ԓ̃bZ[W̍ő咷.
} WIRDVOBJ;

/*!
 *
 * @brief fuԂ̎QƗp\.
 *
 */
typedef struct {
	DWORD		WaitId;			//!< fuI҂^XNIDԍ.
} WIRDVSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitRendPort( void );
void	wi_QuitRendPort( void );
ER		wi_CreateRendPort( INT id, const WIPOROBJ *pk_cpor );
ER		wi_DeleteRendPort( INT id );
ER		wi_CallRendPort( INT id, UINT ptn, VP msg, INT csize, INT *rsize, TMO tmout );
ER		wi_AcceptRendPort( INT id, UINT ptn, INT *no, VP msg, INT *size, TMO tmout );
ER		wi_FowardRendPort( INT id, UINT ptn, INT no, VP msg, INT cmsgsz );
ER		wi_ReplayRendPort( INT no, VP msg, INT size );
ER		wi_RefarenceRendPort( INT id, WIPORSTAT *sts );
ER		wi_RefarenceRendStat( INT no, WIRDVSTAT *sts );
void	wi_AllReleaseRendPort( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_RENDEZVOUS_PORT_H__
/* End of file */
