/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_task.h
 *
 *	@brief	Windows iTRONT[rXR[ (^XN@\).
 *
 *	@author	V 閾
 */
#ifndef	__WI_TASK_H__
#define	__WI_TASK_H__

#include "wi_common.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief ^XNIuWFNg\.
 *
 */
typedef struct _WITSKOBJ {
	WIHDR				Hdr;			//!< IuWFNgwb_.
	struct _WITSKOBJ	*QueLink;		//!< ҂sւ̃Np|C^.
	HANDLE				hThread;		//!< Xbhnh.
	HANDLE				hEvent;			//!< Cxgnh.
	INT					EventType;		//!< Cxg.
	UINT				TaskState;		//!< ^XN.
	unsigned int		ThreadId;		//!< XbhIDԍ.
	ATR					TaskAtr;		//!< ^XN.
	FP					TaskAdr;		//!< ^XNNAhX.
	PRI					TaskPri;		//!< ^XNDx.
	PRI					InitPri;		//!< ^XNN̏Dx.
	INT					StackSize;		//!< X^bNTCY.
	VP					ExtInfo;		//!< g.
	DWORD				StartCode;		//!< ^XNNR[h.
	INT					SuspendCnt;		//!< ^XNf.
	INT					WakeupCnt;		//!< ^XN̋Nv.
	INT					ActiveCnt;		//!< ^XN̋Nv.
	ID					WaitId;			//!< ҂IuWFNgID.
	VP					Param[5];		//!< p̍Ɨ̈.
	BOOL				DelRes;			//!< TRUE = \[X폜ɂ^XN̋N.
	BOOL				RelRes;			//!< TRUE = ҂Ԃ̋ɂ^XN̋N.
} WITSKOBJ;

/*!
 *
 * @brief ^XN̏ԎQƗp\.
 *
 */
typedef struct {
	ATR					TaskAtr;		//!< ^XN.
	FP					TaskAdr;		//!< ^XNNAhX.
	UINT				TaskState;		//!< ^XN.
	PRI					TaskPri;		//!< ^XNDx.
	PRI					InitPri;		//!< ^XNN̏Dx.
	ID					WaitId;			//!< ҂IuWFNgID.
	INT					EventType;		//!< Cxg.
	INT					SuspendCnt;		//!< ^XNf.
	INT					WakeupCnt;		//!< ^XN̋Nv.
	INT					ActiveCnt;		//!< ^XN̋Nv.
	INT					StackSize;		//!< X^bNTCY.
	VP					ExtInfo;		//!< g.
} WITSKSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void		wi_InitTask( void );
void		wi_QuitTask( void );
ER			wi_CreateTask( INT id, const WITSKOBJ *obj );
ER			wi_DeleteTask( INT id );
ER			wi_StartTask( INT id, DWORD start_code, BOOL exist_stcd );
int			wi_CancelStartReq( INT id );
void		wi_ExitTask( void );
void		wi_ExpendTask( void );
ER			wi_TermTask( INT id );
ER			wi_ChangeTaskPriority( INT id, PRI priority );
ER			wi_RefarenceTaskPriority( INT id, PRI *priority );
ER			wi_RefarenceTask( INT id, WITSKSTAT *sts );
ER			wi_SleepTask( TMO tmout );
ER			wi_WakeupTask( INT id );
ER			wi_CancelWakeup( INT id, INT *p_wupcnt );
ER			wi_ReleaseWait( INT id );
ER			wi_SuspendTask( INT id );
ER			wi_ResumeTask( INT id );
ER			wi_ForceResumeTask( INT id );
ER			wi_DelayTask( TMO dlytim );
WITSKOBJ	*wi_GetTaskObject( INT id );
DWORD		wi_GetActiveTaskId( void );
ER			wi_TaskWait( INT wid, INT type, TMO tmout, ATR pri, WIHDR **que );
ER			wi_TaskWakeup( INT id, INT type, WIHDR **que );
WIHDR		*wi_AddWaitTaskList( INT id, ATR pri, WIHDR *que );
WIHDR		*wi_DelWaitTaskList( INT id, WIHDR *que );
DWORD		wi_GetWaitTaskListFirstId( WIHDR *que );
void		wi_WakeupDelResource( WIHDR *que );

#ifdef __cplusplus
}
#endif
#endif	// __WI_TASK_H__
/* End of file */
