/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_cycle_handler.h
 *
 *	@brief	Windows iTRONT[rXR[ (nh).
 *
 *	@author	V 閾
 */
#ifndef	__WI_CYCLE_HANDLER_H__
#define	__WI_CYCLE_HANDLER_H__

#include "wi_common.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief nh\[X\.
 *
 */
typedef struct {
	WIHDR			Hdr;			//!< IuWFNgwb_.
	ATR				Attribute; 		//!< nh.
	FP				CycAdr;			//!< nh̃AhX.
	BOOL			Active;			//!< nh̊.
	DWORDLONG		CycleTime;		//!< NԊԊu.
	DWORDLONG		StartTime;		//!< ŌɎnhĂяo.
	DWORDLONG		CyclePhs; 		//!< Nʑ.
	VP				ExtInfo;		//!< g.
} WICYCOBJ;

/*!
 *
 * @brief nhԂ̎QƗp\.
 *
 */
typedef struct {
	VP			ExtInfo;			//!< g.
	DWORDLONG	LeftTime; 			//!< ̋N܂ł̎.
	BOOL		Active;				//!< nh̊.
} WICYCSTAT;


/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitCycleHadler( void );
void	wi_QuitCycleHadler( void );
ER		wi_DefineCycleHadler( INT no, const WICYCOBJ *obj, BOOL ovr );
ER		wi_DeleteCycleHadler( INT no );
ER		wi_ActionCycleHadler( INT no, BOOL act, BOOL init );
ER		wi_RefarenceCycleHadler( INT no, WICYCSTAT *sts );
void	wi_CycleTimer( DWORDLONG now_time );

#ifdef __cplusplus
}
#endif
#endif	// __WI_CYCLE_HANDLER_H__
/* End of file */
