/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_mail_box.h
 *
 *	@brief	Windows iTRON(Ver3.0)T[rXR[ ([{bNX).
 *
 *	@author	V 閾
 */
#ifndef	__WI_MAIL_BOX_H__
#define	__WI_MAIL_BOX_H__

#include "wi_common.h"
#include "wi_task.h"

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * \̒`.
 *
 ****************************************************************************/
/*!
 *
 * @brief [{bNXIuWFNg\.
 *
 */
typedef struct {
	WIHDR		Hdr;			//!< IuWFNgwb_.
	ATR			Attribute;		//!< [{bNX.
	PRI			MaxPriority;	//!< M郁bZ[WDx̍ől.
	VP			ExtInfo;		//!< g.
	T_MSG		*MsgQue;		//!< bZ[WpPbgXg̃|C^.
	WIHDR		*WaitQue;		//!< ^XN̑҂s̃|C^.
} WIMBXOBJ;

/*!
 *
 * @brief [{bNX̏ԎQƗp\.
 *
 */
typedef struct {
	INT			WaitId;			//!< bZ[W҂s̐擪̃^XNIDԍ.
	T_MSG		*NextMsg;		//!< ɎM郁bZ[W.
	VP			ExtInfo;		//!< g.
} WIMBXSTAT;

/****************************************************************************
 *
 * ֐`.
 *
 ****************************************************************************/
void	wi_InitMailBox( void );
void	wi_QuitMailBox( void );
ER		wi_CreateMailBox( INT id, const WIMBXOBJ *obj );
ER		wi_DeleteMailBox( INT id );
ER		wi_SendMailBox( INT id, T_MSG *msg );
ER		wi_ReceiveMailBox( INT id, T_MSG **msg, TMO tmout );
ER		wi_RefarenceMailBox( INT id, WIMBXSTAT *sts );
void	wi_AllReleaseMailBox( INT id );

#ifdef __cplusplus
}
#endif
#endif	// __WI_MAIL_BOX_H__
/* End of file */
